mpz_t *
encrypt(mpz_t * const mpzIn_p, PubKey const pk, int const no_of_blocks)
{
    int i;
    mpz_t mpztemp, mpzMaske, mpzlambda, *mpzOut_p;

    mpzOut_p = (mpz_t *) malloc(2 * no_of_blocks * sizeof (mpz_t));
    if (mpzOut_p == NULL)
        return (mpzOut_p);

    for (i = 0; i < 2 * no_of_blocks; i++)
        mpz_init(mpzOut_p[i]);

    mpz_init_set_ui(mpzMaske, 1);
    mpz_mul_2exp(mpzMaske, mpzMaske, mpz_sizeinbase(pk.p, 2));
    mpz_sub_ui(mpzMaske, mpzMaske, 1);

    mpz_init(mpztemp);
    mpz_init(mpzlambda);
    srandom(time(NULL));
    for (i = 0; i < no_of_blocks; i++) {
        mpz_sub_ui(mpztemp, pk.p, 2);
        do {
            mpz_random(mpzlambda, mpz_size(pk.p));
            mpz_and(mpzlambda, mpzlambda, mpzMaske);
        }
        while (mpz_cmp(mpzlambda, mpztemp) > 0);

        mpz_powm(mpzOut_p[2*i], pk.alpha, mpzlambda, pk.p);
        mpz_powm(mpzOut_p[2*i+1], pk.beta, mpzlambda, pk.p);
        mpz_mul(mpzOut_p[2*i+1], mpzOut_p[2*i+1], mpzIn_p[i]);
        mpz_mod(mpzOut_p[2*i+1], mpzOut_p[2*i+1], pk.p);
    }
    mpz_clear(mpztemp);
    mpz_clear(mpzMaske);
    mpz_clear(mpzlambda);

    return mpzOut_p;
}
